<script setup>
import { useTaskStore } from "src/stores/task";
import { ref } from "vue";
const props = defineProps({
  task: {
    type: Object,
  },
});

const emits = defineEmits({
  onSelectTask(task) {
    return task;
  },
});

const task = ref(props.task);
const taskStore = useTaskStore();

const toggleIsDone = () => {
  taskStore.toggleIsDone(task.value.id);
  task.value.is_done = !task.value.is_done;
};

const deleteTask = () => {
  taskStore.deleteTask(props.task.id);
};

const onEditTask = () => {
  emits("onSelectTask", task.value);
};
</script>

<template>
  <q-item v-ripple>
    <q-item-section avatar top>
      <q-checkbox
        v-model="task.is_done"
        @update:model-value="toggleIsDone"
        val="primary"
        color="green"
      />
    </q-item-section>
    <q-item-section @click="onEditTask">
      <q-item-label :class="task.is_done ? 'text-strike' : ''">{{
        task.name
      }}</q-item-label>
      <q-item-label
        lines="1"
        caption
        :class="task.is_done ? 'text-strike' : ''"
      >
        {{ task.description }}
      </q-item-label>
    </q-item-section>
    <q-item-section side>
      <q-btn @click="deleteTask" flat color="gray" icon="mdi-delete"></q-btn>
    </q-item-section>
  </q-item>
  <q-separator></q-separator>
</template>
